## frama-c 20130601+fluorine3+dfsg

=== Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2013                                               #
#    CEA (Commissariat  l'nergie atomique et aux nergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# This file is the main makefile of Frama-C.

FRAMAC_SRC=.
MAKECONFIG_DIR=share

include share/Makefile.common

###################
# Frama-C Version #
###################

VERSION=$(shell $(SED) -e 's/\\(.*\\)/\\1/' VERSION)

ifeq ($(findstring +dev,$(VERSION)),+dev)
DEVELOPMENT=yes
else
DEVELOPMENT=no
endif

###########################
# Global plugin variables #
###########################

# the directory where compiled plugin files are stored
PLUGIN_LIB_DIR	= lib/plugins
PLUGIN_GUI_LIB_DIR= lib/plugins/gui

# the directory where the other Makefiles are
FRAMAC_SHARE	= share

# set it to yes to tell Makefile.dynamic than we come from here
FRAMAC_MAKE	=yes

# Shared lists between Makefile.plugin and Makefile :
# initialized them as "simply extended variables" (with :=)
# for a correct behavior of += (see section 6.6 of GNU Make manual)
PLUGIN_LIST	:=
PLUGIN_DYN_EXISTS:="no"
PLUGIN_DYN_LIST :=
PLUGIN_CMO_LIST	:=
PLUGIN_CMX_LIST	:=
PLUGIN_DYN_CMO_LIST :=
PLUGIN_DYN_CMX_LIST :=
PLUGIN_INTERNAL_CMO_LIST:=
PLUGIN_INTERNAL_CMX_LIST:=
PLUGIN_DEP_GUI_CMO_LIST:=
PLUGIN_DEP_GUI_CMX_LIST:=
PLUGIN_GUI_CMO_LIST:=
PLUGIN_GUI_CMX_LIST:=
PLUGIN_DYN_DEP_GUI_CMO_LIST:=
PLUGIN_DYN_DEP_GUI_CMX_LIST:=
PLUGIN_DYN_GUI_CMO_LIST :=
PLUGIN_DYN_GUI_CMX_LIST :=
PLUGIN_TYPES_CMO_LIST :=
PLUGIN_TYPES_CMX_LIST :=
PLUGIN_DEP_LIST:=
PLUGIN_DOC_LIST :=
PLUGIN_DOC_DIRS :=
PLUGIN_DISTRIBUTED_LIST:=
PLUGIN_DIST_TARGET_LIST:=
PLUGIN_DIST_DOC_LIST:=
PLUGIN_BIN_DOC_LIST:=
PLUGIN_DIST_EXTERNAL_LIST:=
PLUGIN_TESTS_LIST:=
PLUGIN_DISTRIBUTED_NAME_LIST:=

CEA_WP:=

###############################
# Additional global variables #
###############################

# put here any config option for the binary distribution outside of
# plugins
CONFIG_DISTRIB_BIN:=

# additional compilation targets for 'make all'.
# cannot be delayed after 'make all'
EXTRAS	= ptests

# Directories containing some source code
SRC_DIRS= ptests $(PLUGIN_LIB_DIR)

# Directory containing source code documentation
DOC_DIR	= doc/code

# Source files to document
MODULES_TODOC=

# Directories containing some source code
SRC_DIRS+= $(FRAMAC_SRC_DIRS)

# Directories to include when compiling
INCLUDES=$(addprefix -I , $(FRAMAC_SRC_DIRS)) -I $(PLUGIN_LIB_DIR) -I lib

# Directories to include for ocamldep
# Remove -I +.* and -I C:/absolute/win/path 
INCLUDES_FOR_OCAMLDEP= $(shell echo $(INCLUDES) $(GUI_INCLUDES) | $(SED) -e "s/-I *.:[^ ]*//g" -e "s/-I *+[^ ]*//g" -e "s|-I *$(LABLGTK_PATH)[^ ]*||g")

# Ocamldep flags
DEP_FLAGS= $(INCLUDES_FOR_OCAMLDEP)

# Files for which dependencies are computed
FILES_FOR_OCAMLDEP+=$(PLUGIN_LIB_DIR)/*.mli \
		$(addsuffix /*.mli, $(UNPACKED_DIRS)) \
		$(addsuffix /*.ml, $(UNPACKED_DIRS))

# Flags to use by ocamlc and ocamlopt
ifeq ($(DEVELOPMENT),yes)
ifeq ($(HAS_OCAML312),yes)
ifeq ($(WARN_ERROR_ALL),yes)
DEV_FLAGS=$(FLAGS) -warn-error +a
else
DEV_FLAGS=$(FLAGS) -warn-error +a-32-33-34-35-36-37-38-39
endif #WARN_ERROR_ALL
else
DEV_FLAGS=$(FLAGS) -warn-error A
endif #HAS_OCAML312
else
DEV_FLAGS=$(FLAGS)
endif #DEVELOPMENT

BFLAGS	= $(DEV_FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_BYTE) \
	  $(OCAMLVIZ_COMPILER_BYTE) $(OUNIT_COMPILER_BYTE)
OFLAGS	= $(DEV_FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_OPT) \
	  $(GPROFOPT) $(OCAMLVIZ_COMPILER_OPT) $(OUNIT_COMPILER_OPT) -compact

BLINKFLAGS += $(BFLAGS) -linkall -custom
OLINKFLAGS += $(OFLAGS) -linkall

DOC_FLAGS= -colorize-code -stars -inv-merge-ml-mli -m A -hide-warnings \
	$(INCLUDES) $(GUI_INCLUDES)

# Libraries generated by Frama-C
GEN_BYTE_LIBS=
GEN_OPT_LIBS=

# Libraries used in Frama-C
EXTRA_OPT_LIBS:=
BYTE_LIBS = nums.cma unix.cma bigarray.cma str.cma dynlink.cma \
	$(GEN_BYTE_LIBS)
OPT_LIBS = nums.cmxa unix.cmxa bigarray.cmxa str.cmxa $(EXTRA_OPT_LIBS)

ifeq ("$(NATIVE_DYNLINK)","yes")
OPT_LIBS+= dynlink.cmxa
endif

OPT_LIBS+= $(GEN_OPT_LIBS)

ICONS:= $(addprefix share/, \
		frama-c.ico frama-c.gif unmark.png )

FEEDBACK_ICONS:= $(addprefix share/feedback/, \
		never_tried.png \
		unknown.png \
		surely_valid.png \
		surely_invalid.png \
		considered_valid.png \
		valid_under_hyp.png \
		invalid_under_hyp.png \
		invalid_but_dead.png \
		unknown_but_dead.png \
		valid_but_dead.png \
		inconsistent.png \
		switch-on.png \
		switch-off.png )

ROOT_LIBC_DIR:= share/libc
LIBC_SUBDIRS:= . sys netinet linux net arpa
LIBC_DIR:= $(addprefix $(ROOT_LIBC_DIR)/, $(LIBC_SUBDIRS))
FREE_LIBC:= \
	share/*.h share/*.c \
	$(addsuffix /*.h, $(LIBC_DIR)) \
	$(ROOT_LIBC_DIR)/./__fc_builtin_for_normalization.i \
NONFREE_LIBC:= $(addsuffix /*.[ci], $(LIBC_DIR))

# Kernel files to be included in the distribution.
# Plug-ins should use PLUGIN_DISTRIB_EXTERNAL if they export something else
# than *.ml* files in their directory.
# NB: configure for the distribution is generated in the distrib directory
# itself, rather than copied: otherwise, it could include references to
# non-distributed plug-ins.
DISTRIB_FILES:= cil/*/*.ml* cil/*/*.in        				\
      $(filter-out cil/src/frontc/cparser.ml cil/src/frontc/cparser.mli \
          cil/src/logic/logic_lexer.ml cil/src/logic/logic_parser.mli   \
          cil/src/logic/logic_parser.ml cil/src/frontc/clexer.ml        \
          cil/src/logic/logic_preprocess.ml,                            \
	  $(wildcard cil/src/*/*.ml*))                                  \
      bin/oxygen2fluorine.sh						\
      share/frama-c.WIN32.rc share/frama-c.Unix.rc                      \
      $(ICONS) $(FEEDBACK_ICONS)			 		\
      man/frama-c.1 doc/manuals/*.pdf doc/README			\
      doc/code/docgen_*.ml						\
      doc/code/*.css doc/code/intro_plugin.txt				\
      doc/code/intro_plugin_D_and_S.txt                                 \
      doc/code/intro_plugin_default.txt                                 \
      doc/code/intro_kernel_plugin.txt doc/code/intro_occurrence.txt	\
      doc/code/intro_pdg.txt doc/code/intro_scope.txt			\
      doc/code/intro_slicing.txt doc/code/intro_sparecode.txt		\
      doc/code/intro_wp.txt doc/code/toc_head.htm			\
      doc/code/toc_tail.htm                                             \
      doc/code/print_api/*.ml* doc/code/print_api/Makefile              \
      tests/*/*.c tests/*/*.i tests/*/*.h tests/*/*.ml			\
      $(filter-out ptests/ptests_config.ml, $(wildcard ptests/*.ml*))   \
      configure.in Makefile                      			\
      share/Makefile.plugin share/Makefile.dynamic			\
      share/Makefile.dynamic_config.internal				\
      share/Makefile.dynamic_config.external Changelog config.h.in	\
      VERSION licenses/* 						\
      $(FREE_LIBC)                                                      \
      share/acsl.el share/configure.ac					\
      share/Makefile.config.in share/Makefile.common			\
      share/Makefile.plugin share/Makefile.dynamic			\
      share/Makefile.dynamic_config.external				\
      share/Makefile.dynamic_config.internal		   		\
      $(filter-out src/kernel/config.ml, $(wildcard src/kernel/*.ml*))  \
      external/hptmap.ml* external/unmarshal*.ml* external/unz.ml*      \
      external/sysutil.ml* \
      src/ai/*.ml* src/buckx/*.ml*				 	\
      src/buckx/*.c src/gui/*.ml* src/logic/*.ml*                       \
      $(filter-out src/lib/integer.ml                                   \
         src/lib/dynlink_common_interface.ml,				\
	$(wildcard src/lib/*.ml*)) 					\
      src/memory_state/*.ml* src/misc/*.ml* src/project/*.ml*		\
      src/printer/*.ml* src/toplevel/toplevel_config.ml src/type/*.ml*  \
      bin/sed_get_make_major bin/sed_get_make_minor                     \
      INSTALL INSTALL_WITH_WHY .make-clean	                        \
      .make-clean-stamp .make-ocamlgraph-stamp .force-reconfigure

# files that are needed to compile API documentation of external plugins
DOC_GEN_FILES:=$(addprefix doc/code/, \
	*.css intro_plugin.txt intro_kernel_plugin.txt \
	intro_plugin_default.txt intro_plugin_D_and_S \
	kernel-doc.ocamldoc \
	docgen_*.ml docgen.cm* *.htm)

################
# Main targets #
################

ifneq ($(ENABLE_GUI),no)
ifeq ($(HAS_LABLGTK),yes)
EXTRAS	+= gui
endif
endif

all:: byte $(OCAMLBEST) $(EXTRAS)

.PHONY: top opt byte dist bdist archclean rebuild
top: bin/toplevel.top$(EXE)
	$(MAKE) install-kernel-byte FRAMAC_LIBDIR=lib/fc

byte:: bin/toplevel.byte$(EXE) \
      share/Makefile.dynamic_config share/Makefile.kernel
	$(MAKE) install-kernel-byte FRAMAC_LIBDIR=lib/fc

opt:: bin/toplevel.opt$(EXE) \
     share/Makefile.dynamic_config share/Makefile.kernel
	$(MAKE) install-kernel-opt FRAMAC_LIBDIR=lib/fc

dist: clean
	$(QUIET_MAKE) OPTIM="-unsafe -noassert" DEBUG="" all

bdist: clean
	$(QUIET_MAKE) OPTIM="-unsafe -noassert" DEBUG="" byte

ifneq ("$(OCAMLGRAPH_LOCAL)","")
archclean: clean
	$(MAKE) -C $(OCAMLGRAPH_LOCAL) distclean
	cd $(OCAMLGRAPH_LOCAL) ; ./configure

rebuild: archclean
	$(MAKE) -C $(OCAMLGRAPH_LOCAL)
	$(QUIET_MAKE) all
else
archclean: clean

rebuild: archclean
	$(QUIET_MAKE) all
endif

############
# Coverage #
############

USE_COVERAGE_TOOL=no
ifeq ($(USE_COVERAGE_TOOL),yes)
COVERAGE_PATH=.
COVERAGE_PREPRO=camlp4o -no_quot -filter $(COVERAGE_PATH)/coverage_filter.cmo
COVERAGE_COMPILER_BYTE=-I $(COVERAGE_PATH) -pp "$(COVERAGE_PREPRO)"
COVERAGE_COMPILER_OPT=-I $(COVERAGE_PATH) -pp "$(COVERAGE_PREPRO)"
COVERAGE_LIB_BYTE=coverage.cma
COVERAGE_LIB_OPT=coverage.cmxa
endif

INCLUDES+=$(COVERAGE_COMPILER_BYTE)
GEN_BYTE_LIBS+=$(COVERAGE_LIB_BYTE)
GEN_OPT_LIBS+=$(COVERAGE_LIB_OPT)
SRC_DIRS+=$(COVERAGE_PATH)

########################
# Ocamlviz (profiling) #
########################

# To use OCamlviz you need to fix its makefile :-(
# In $(OCAMLVIZ_PATH)/Makefile.in change the line
# OCAMLVIZCMO = $(PROTOCOLCMO) src/monitor_impl.cmo src/ocamlviz.cmo src/ocamlviz_threads.cmo
# into
# OCAMLVIZCMO = $(PROTOCOLCMO) src/monitor_impl.cmo src/ocamlviz.cmo
# and
# cp -f src/ocamlviz.mli src/ocamlviz.cmi src/ocamlviz_threads.cmi $(OCAMLLIB)
# into
# cp -f src/ocamlviz.mli src/ocamlviz.cmi $(OCAMLLIB)
#
# Then run "./configure && make && make install" in $(OCAMLVIZ_PATH)
# Only one instance of Frama-C can be launched at a time when Ocamlviz is on.
USE_OCAMLVIZ_TOOL=no
ifeq ($(USE_OCAMLVIZ_TOOL),yes)
OCAMLVIZ_PATH=~/src/ocamlviz
OCAMLVIZ_COMPILER_BYTE=-I $(OCAMLVIZ_PATH)/src # -pp "camlp4 pa_o.cmo str.cma $(OCAMLVIZ_PATH)/camlp4/pa_ocamlviz.cmo pr_o.cmo"
# Seems really broken and generates fatal warnings
OCAMLVIZ_COMPILER_OPT=-I $(OCAMLVIZ_PATH)/src
OCAMLVIZ_LIB_BYTE=~/lib/ocaml/libocamlviz.cma

=== src/dummy/hello_world/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2013                                               #
#    CEA (Commissariat  l'nergie atomique et aux nergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# Example of Makefile for dynamic plugins
#########################################

# Frama-c should be properly installed with "make install" 
# before any use of this makefile

FRAMAC_SHARE  	:=$(shell frama-c.byte -print-path)
FRAMAC_LIBDIR 	:=$(shell frama-c.byte -print-libpath)
PLUGIN_NAME	= Hello
PLUGIN_CMO	= hello_world
include $(FRAMAC_SHARE)/Makefile.dynamic

=== src/dummy/untyped_metrics/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2013                                               #
#    CEA (Commissariat  l'nergie atomique et aux nergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# Generic Makefile for bytecode plugins

FRAMAC_SHARE=$(shell frama-c -print-path)

PLUGIN_NAME=Untyped_metrics
PLUGIN_CMO=count_for

include $(FRAMAC_SHARE)/Makefile.dynamic

=== src/wp/share/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of WP plug-in of Frama-C.                           #
#                                                                        #
#  Copyright (C) 2007-2013                                               #
#    CEA (Commissariat a l'energie atomique et aux energies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# --------------------------------------------------------------------------
# ---  Shared Resources for WP 0.7                                       ---
# --------------------------------------------------------------------------

.PHONY: all coq depend

all: coq

# --------------------------------------------------------------------------
# ---  Coq Libraries for WP                                              ---
# --------------------------------------------------------------------------

COQL= Qedlib Cint Bits Cbits Cfloat Cmath Vset Memory 
COQSRC= $(addsuffix .v,$(COQL))
COQBIN= $(addsuffix .vo,$(COQL))
COQREF= $(addsuffix .glob,$(COQL))

coq: $(COQBIN)

# --------------------------------------------------------------------------

clean:
	rm -f *.vo *~ *.glob *.cm?
	rm -fr html/*

depend:
	coqdep -I . *.v > .depend

.SUFFIXES: .v .vo

.v.vo:
	coqc -I . $<

sinclude .depend
sinclude Makefile.wp # Wp developers only

# --------------------------------------------------------------------------

=== src/wp/qed/src/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of WP plug-in of Frama-C.                           #
#                                                                        #
#  Copyright (C) 2007-2013                                               #
#    CEA (Commissariat a l'energie atomique et aux energies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# --------------------------------------------------------------------------
# ---  QED : a prover / simplifier in classical logic modulo             ---
# --------------------------------------------------------------------------

PACK?=no

include Makefile.src

LIB_ML:=$(QED_LIB_ML)
SRC_ML:=$(QED_SRC_ML)
SRC_MLI:=$(QED_SRC_MLI)

LBO= $(addsuffix .cmo,$(LIB_ML))
LBX= $(addsuffix .cmx,$(LIB_ML))
CML= $(addsuffix .cmi,$(SRC_MLI))
CMI= $(CML) $(addsuffix .cmi,$(SRC_ML))
CMO= $(addsuffix .cmo,$(SRC_ML))
CMX= $(addsuffix .cmx,$(SRC_ML))
DOC= $(addsuffix .mli,$(LIB_ML) $(SRC_MLI) $(SRC_ML))

.PHONY: all byte opt doc

all:  byte opt
byte: ../bin/Qed.cmo Makefile Makefile.src
opt:  ../bin/Qed.cmx Makefile Makefile.src
doc:  ../html/index.html

Qed.cmo: $(LBO) $(CMO) $(CML)
	$(OCAMLC) -pack -o $@ $(LBO) $(CML) $(CMO)

ifeq ($(PACK),no)
Qed.cmx: $(LBX) $(CMX) $(CML)
	$(OCAMLOPT) -pack -o $@ $(LBX) $(CML) $(CMX)
else
Qed.cmx: $(LBX) $(CMX) $(CML)
	$(OCAMLOPT) -pack -for-pack $(PACK) -o $@ $(LBX) $(CML) $(CMX)
endif


../bin/Qed.cmo: Qed.cmo
	@mkdir -p ../bin
	cp Qed.cmo Qed.cmi ../bin/

../bin/Qed.cmx: Qed.cmx
	@mkdir -p ../bin
	cp Qed.cmx Qed.cmi Qed.o ../bin/

../html/index.html: $(DOC) Makefile
	@rm -fr ../html
	@mkdir -p ../html
	$(OCAMLDOC) -html -d ../html -t "Qed Library" -stars $(DOC)
	@cp -f ocamldoc.css ../html/style.css

depend: lexer.ml numbers.ml

depend.pdf: depend.dot
	dot -T pdf -Grotate=180 -o $@ $<

depend.dot: .depend
	$(OCAMLDOC) -dot-reduce -o $@ -dot $(addsuffix .mli,$(SRC_MLI)) $(addsuffix .ml,$(LIB_ML) $(SRC_ML))

clean::
	rm -fr ../html
	rm -f lexer.ml depend.dot depend.pdf

distclean::
	rm -f ../bin/Qed.*

INCLUDES=
OPTCMI=
OPTCMO= -w PSUZ -warn-error PSUZ
ifeq ($(PACK),no)
OPTCMX= -w PSUZ -warn-error PSUZ -for-pack Qed
else
OPTCMX= -w PSUZ -warn-error PSUZ -for-pack $(PACK).Qed
endif

include MakeOcaml

=== debian/changelog ===
frama-c (20130601+fluorine3+dfsg-2build1) trusty; urgency=medium

  * Rebuild for ocaml-4.01.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Dec 2013 22:01:50 +0000

frama-c (20130601+fluorine3+dfsg-2) unstable; urgency=low

  * Team upload
  * debian/patches:
    + Fix compilation with OCaml 4.01.0 (Closes: #731637)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 08 Dec 2013 12:25:21 +0100

frama-c (20130601+fluorine3+dfsg-1) unstable; urgency=low

  * New upstream release (Closes: #714124)
    - Remove 0001-Add-ocamlgraph-to-DYN_-O-B-LINKFLAGS.patch, fixed
      upstream
    - Remove 0002-Accept-ocamlgraph-1.8.patch, fixed upstream
    - Remove 0006-Patchlevel2-for-Nitrogen-20111001.patch, integrated
    - Add 0004-Fix-auto-detection-of-ocaml-zarith.patch
    - Require ocamlgraph (>= 1.8.3~) on build.
  * Add libzarith-ocaml-dev to Build-Depends.
  * Add autoconf to Build-Depends.
  * Call dh_ocaml with --nodefined-map=frama-c-base:Big_int_Z,Z,Q, modules
    already declared by ocaml-zarith.

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 25 Nov 2013 15:02:35 +0100

=== debian/control ===
Source: frama-c
Section: devel
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Mehdi Dogguy <mehdi@debian.org>
Build-Depends:
 debhelper (>= 7.0.50~),
 ocaml-nox (>= 3.12.0~),
 ocaml-best-compilers,
 dh-ocaml (>= 0.9~),
 graphviz,
 autoconf,
 libzarith-ocaml-dev,
 libocamlgraph-viewer-ocaml-dev (>> 1.8.3~),
 liblablgtk2-gnome-ocaml-dev (>= 2.14.0+dfsg-2~),
 liblablgtksourceview2-ocaml-dev (>= 2.14.0+dfsg-2~)
Standards-Version: 3.9.2
Homepage: http://frama-c.com/
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/frama-c.git
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/frama-c.git

Package: frama-c
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 frama-c-base (= ${binary:Version}),
 graphviz,
 emacs | emacsen
Recommends:
 why (>= 2.19+dfsg-2),
Description: Framework for source code analysis of software written in C
 Frama-C is a framework dedicated to the analysis of the source code
 of software written in C.
 .
 Frama-C gathers several static analysis techniques in a single
 collaborative framework. The collaborative approach of Frama-C allows
 static analyzers to build upon the results already computed by other
 analyzers in the framework. Thanks to this approach, Frama-C provides
 sophisticated tools, such as a slicer and dependency analysis.
 .
 It can be used to:
   * Validate the source code formally
   * Look for potential runtime errors
   * Audit or review it
   * Reverse engineer it to understand its structure
   * Generate formal documentation
 .
 This package provides the graphical user interface of Frama-c and depends
 on frama-c-base.

Package: frama-c-base
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 libocamlgraph-ocaml-dev,
 gcc,
Recommends:
 alt-ergo,
 libwhy-coq
Replaces: frama-c (<< 20090902+beryllium+dfsg-1)
Breaks: frama-c (<< 20090902+beryllium+dfsg-1)
Description: Framework for C source code analysis (without gui)
 Frama-C is a framework dedicated to the analysis of the source code
 of software written in C.
 .
 Frama-C gathers several static analysis techniques in a single
 collaborative framework. The collaborative approach of Frama-C allows
 static analyzers to build upon the results already computed by other
 analyzers in the framework. Thanks to this approach, Frama-C provides
 sophisticated tools, such as a slicer and dependency analysis.
 .
 It can be used to:
   * Validate the source code formally
   * Look for potential runtime errors
   * Audit or review it
   * Reverse engineer it to understand its structure
   * Generate formal documentation
 .
 This package provides the library of Frama-c which is useful to build
 plugins for Frama-c and the command-line tools.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

FRAMA_DIR=$(CURDIR)/debian/tmp

override_dh_auto_configure:
	mkdir -p lib/plugins
	mkdir -p lib/gui
	touch .depend .make-clean .make-clean-stamp
	[ ! -f src/kernel/config.ml ] || cp src/kernel/config.ml src/kernel/config.ml.debian
	./configure $(CROSS) --prefix=/usr       \
		--mandir=\$${prefix}/share/man   \
		--infodir=\$${prefix}/share/info \
		--datarootdir=\$${prefix}/share  \
		--disable-impact		 \
		--disable-security		 \
		--enable-verbosemake             \
		CFLAGS="$(CFLAGS)"               \
		LDFLAGS="-Wl,-z,defs"

override_dh_auto_install:
	$(MAKE) prefix=$(FRAMA_DIR)/usr FRAMAC_DATADIR=$(FRAMA_DIR)/usr/share/frama-c install
	# Fix permission of .c and .h files (they don't have to be executable)
	find debian/ -name "*.c" -or -name "*.h" -exec chmod a-x '{}' \;
	cp debian/icons/frama-c.svg $(CURDIR)/debian/frama-c/usr/share/icons/hicolor/scalable/apps/
	cp debian/icons/frama-c.xpm $(CURDIR)/debian/frama-c/usr/share/pixmaps/
	cp debian/frama-c.desktop $(CURDIR)/debian/frama-c/usr/share/applications/
	$(RM) -f $(CURDIR)/debian/frama-c/usr/bin/frama-c-gui.byte
	$(RM) -f $(CURDIR)/debian/frama-c/usr/bin/ptests.byte
	# Same file as frama-c.1. We use a symlink instead of copying the file twice
	$(RM) -f $(FRAMA_DIR)/usr/share/man/man1/frama-c-gui.1
ifeq ($(OCAML_OPT_ARCH),)
	$(RM) -f $(CURDIR)/debian/frama-c/usr/bin/frama-c.byte
endif

override_dh_auto_clean:
	touch .depend
	[ ! -f src/kernel/config.ml.debian ] || mv src/kernel/config.ml.debian src/kernel/config.ml
	[ ! -f Makefile -o ! -f share/Makefile.config ] || $(MAKE) clean
	$(RM) -rf lib .depend

override_dh_ocaml:
	dh_ocaml --nodefined-map=frama-c-base:Big_int_Z,Z,Q

%:
	dh --with ocaml $@

## frama-c 20140301+neon+dfsg

=== Makefile ===
--- 
+++ 
@@ -2,8 +2,8 @@
 #                                                                        #
 #  This file is part of Frama-C.                                         #
 #                                                                        #
-#  Copyright (C) 2007-2013                                               #
-#    CEA (Commissariat  l'nergie atomique et aux nergies              #
+#  Copyright (C) 2007-2014                                               #
+#    CEA (Commissariat à l'énergie atomique et aux énergies              #
 #         alternatives)                                                  #
 #                                                                        #
 #  you can redistribute it and/or modify it under the terms of the GNU   #
@@ -87,6 +87,8 @@
 PLUGIN_DISTRIBUTED_NAME_LIST:=
 
 CEA_WP:=
+UNMODIFIED_WHY3:=
+MODIFIED_WHY3:=
 
 ###############################
 # Additional global variables #
@@ -117,10 +119,12 @@
 
 # Directories to include for ocamldep
 # Remove -I +.* and -I C:/absolute/win/path 
-INCLUDES_FOR_OCAMLDEP= $(shell echo $(INCLUDES) $(GUI_INCLUDES) | $(SED) -e "s/-I *.:[^ ]*//g" -e "s/-I *+[^ ]*//g" -e "s|-I *$(LABLGTK_PATH)[^ ]*||g")
+INCLUDES_FOR_OCAMLDEP=$(addprefix -I , $(FRAMAC_SRC_DIRS)) \
+                      -I $(PLUGIN_LIB_DIR) -I lib
 
 # Ocamldep flags
-DEP_FLAGS= $(INCLUDES_FOR_OCAMLDEP)
+DEP_FLAGS= $(shell echo $(INCLUDES_FOR_OCAMLDEP) \
+             | $(SED) -e "s/-I *.:[^ ]*//g" -e "s/-I *+[^ ]*//g")
 
 # Files for which dependencies are computed
 FILES_FOR_OCAMLDEP+=$(PLUGIN_LIB_DIR)/*.mli \
@@ -129,15 +133,11 @@
 
 # Flags to use by ocamlc and ocamlopt
 ifeq ($(DEVELOPMENT),yes)
-ifeq ($(HAS_OCAML312),yes)
 ifeq ($(WARN_ERROR_ALL),yes)
 DEV_FLAGS=$(FLAGS) -warn-error +a
 else
 DEV_FLAGS=$(FLAGS) -warn-error +a-32-33-34-35-36-37-38-39
 endif #WARN_ERROR_ALL
-else
-DEV_FLAGS=$(FLAGS) -warn-error A
-endif #HAS_OCAML312
 else
 DEV_FLAGS=$(FLAGS)
 endif #DEVELOPMENT
@@ -193,8 +193,39 @@
 FREE_LIBC:= \
 	share/*.h share/*.c \
 	$(addsuffix /*.h, $(LIBC_DIR)) \
-	$(ROOT_LIBC_DIR)/./__fc_builtin_for_normalization.i \
+	$(ROOT_LIBC_DIR)/./__fc_builtin_for_normalization.i
+
 NONFREE_LIBC:= $(addsuffix /*.[ci], $(LIBC_DIR))
+
+
+# Checks that all .h can be included multiple times.
+ALL_LIBC_HEADERS:=$(wildcard share/*.h $(addsuffix /*.h, $(LIBC_DIR)))
+
+check-libc: bin/toplevel.$(OCAMLBEST)$(EXE)
+	@echo "checking libc..."; \
+	 EXIT_VALUE=0; \
+	 for file in $(ALL_LIBC_HEADERS); do \
+	   echo "#include \"$$file\"" > check-libc.c; \
+	   echo "#include \"$$file\"" >> check-libc.c; \
+	   FRAMAC_SHARE=share bin/toplevel.$(OCAMLBEST)$(EXE) \
+           -cpp-extra-args="-Ishare/libc -nostdinc" check-libc.c \
+               > $$(basename $$file .h).log 2>&1; \
+	   if test $$? -ne 0; then \
+	     if grep -q -e '#error "Frama-C:' $$file; then : ; \
+	     else \
+	       echo "$$file cannot be included twice. \
+Output is in $$(basename $$file .h).log"; \
+	       EXIT_VALUE=1; \
+	     fi; \
+	   else \
+	     rm $$(basename $$file .h).log; \
+           fi; \
+	 done; \
+	 rm check-libc.c; \
+	 exit $$EXIT_VALUE
+
+clean-check-libc:
+	$(RM) *.log
 
 # Kernel files to be included in the distribution.
 # Plug-ins should use PLUGIN_DISTRIB_EXTERNAL if they export something else
@@ -208,7 +239,7 @@
           cil/src/logic/logic_parser.ml cil/src/frontc/clexer.ml        \
           cil/src/logic/logic_preprocess.ml,                            \
 	  $(wildcard cil/src/*/*.ml*))                                  \
-      bin/oxygen2fluorine.sh						\
+      bin/*2*.sh							\
       share/frama-c.WIN32.rc share/frama-c.Unix.rc                      \
       $(ICONS) $(FEEDBACK_ICONS)			 		\
       man/frama-c.1 doc/manuals/*.pdf doc/README			\
@@ -231,13 +262,14 @@
       VERSION licenses/* 						\
       $(FREE_LIBC)                                                      \
       share/acsl.el share/configure.ac					\
-      share/Makefile.config.in share/Makefile.common			\
+      share/Makefile.config.in share/Makefile.common                    \
+      share/Makefile.generic			                        \
       share/Makefile.plugin share/Makefile.dynamic			\
       share/Makefile.dynamic_config.external				\
       share/Makefile.dynamic_config.internal		   		\
       $(filter-out src/kernel/config.ml, $(wildcard src/kernel/*.ml*))  \
       external/hptmap.ml* external/unmarshal*.ml* external/unz.ml*      \
-      external/sysutil.ml* \
+      external/sysutil.ml* 			\
       src/ai/*.ml* src/buckx/*.ml*				 	\
       src/buckx/*.c src/gui/*.ml* src/logic/*.ml*                       \
       $(filter-out src/lib/integer.ml                                   \
@@ -294,52 +326,26 @@
 rebuild: archclean
 	$(MAKE) -C $(OCAMLGRAPH_LOCAL)
 	$(QUIET_MAKE) all
+
+OCAMLGRAPH_MERLIN="S `readlink -f $(OCAMLGRAPH_LOCAL)`\\nB `readlink -f $(OCAMLGRAPH_LOCAL)`"
 else
 archclean: clean
 
 rebuild: archclean
 	$(QUIET_MAKE) all
-endif
+
+OCAMLGRAPH_MERLIN="PKG ocamlgraph"
+endif
+
+.PHONY:merlin
+merlin:
+#create Merlin file
+	find `echo "src cil external" | xargs -n 1 -d ' ' readlink -f` \( -name .svn -name tests -o -name doc -o -name result -o -name -o -name oracle -o -name "*.cache" \) -prune -o \( -type d -printf "B %p\nS %p\n"  \) > .merlin
+	echo $(OCAMLGRAPH_MERLIN) >> .merlin
+	echo "PKG zarith" >> .merlin
 
 ############
 # Coverage #
 ############
 
 USE_COVERAGE_TOOL=no
-ifeq ($(USE_COVERAGE_TOOL),yes)
-COVERAGE_PATH=.
-COVERAGE_PREPRO=camlp4o -no_quot -filter $(COVERAGE_PATH)/coverage_filter.cmo
-COVERAGE_COMPILER_BYTE=-I $(COVERAGE_PATH) -pp "$(COVERAGE_PREPRO)"
-COVERAGE_COMPILER_OPT=-I $(COVERAGE_PATH) -pp "$(COVERAGE_PREPRO)"
-COVERAGE_LIB_BYTE=coverage.cma
-COVERAGE_LIB_OPT=coverage.cmxa
-endif
-
-INCLUDES+=$(COVERAGE_COMPILER_BYTE)
-GEN_BYTE_LIBS+=$(COVERAGE_LIB_BYTE)
-GEN_OPT_LIBS+=$(COVERAGE_LIB_OPT)
-SRC_DIRS+=$(COVERAGE_PATH)
-
-########################
-# Ocamlviz (profiling) #
-########################
-
-# To use OCamlviz you need to fix its makefile :-(
-# In $(OCAMLVIZ_PATH)/Makefile.in change the line
-# OCAMLVIZCMO = $(PROTOCOLCMO) src/monitor_impl.cmo src/ocamlviz.cmo src/ocamlviz_threads.cmo
-# into
-# OCAMLVIZCMO = $(PROTOCOLCMO) src/monitor_impl.cmo src/ocamlviz.cmo
-# and
-# cp -f src/ocamlviz.mli src/ocamlviz.cmi src/ocamlviz_threads.cmi $(OCAMLLIB)
-# into
-# cp -f src/ocamlviz.mli src/ocamlviz.cmi $(OCAMLLIB)
-#
-# Then run "./configure && make && make install" in $(OCAMLVIZ_PATH)
-# Only one instance of Frama-C can be launched at a time when Ocamlviz is on.
-USE_OCAMLVIZ_TOOL=no
-ifeq ($(USE_OCAMLVIZ_TOOL),yes)
-OCAMLVIZ_PATH=~/src/ocamlviz
-OCAMLVIZ_COMPILER_BYTE=-I $(OCAMLVIZ_PATH)/src # -pp "camlp4 pa_o.cmo str.cma $(OCAMLVIZ_PATH)/camlp4/pa_ocamlviz.cmo pr_o.cmo"
-# Seems really broken and generates fatal warnings
-OCAMLVIZ_COMPILER_OPT=-I $(OCAMLVIZ_PATH)/src
-OCAMLVIZ_LIB_BYTE=~/lib/ocaml/libocamlviz.cma

=== doc/code/print_api/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2014                                               #
#    CEA (Commissariat à l'énergie atomique et aux énergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# Print_api plugin
##################

# Frama-C should be properly installed with "make install"
# befor any use of this makefile

ifndef FRAMAC_SHARE
FRAMAC_SHARE	:=$(shell frama-c.byte -print-path)
endif
ifndef FRAMAC_LIBDIR
FRAMAC_LIBDIR	:=$(shell frama-c.byte -print-libpath)
endif

PLUGIN_DIR	?= .
PLUGIN_NAME	:= Print_api
PLUGIN_CMO	:= grammar lexer print_interface
PLUGIN_GENERATED:= $(PLUGIN_DIR)/grammar.ml $(PLUGIN_DIR)/grammar.mli \
		$(PLUGIN_DIR)/lexer.ml

include $(FRAMAC_SHARE)/Makefile.dynamic

clean:: 
	$(RM) $(Print_api_DIR)/dynamic_plugins.mli
	$(RM) $(Print_api_DIR)/grammar.output
	$(RM) $(Print_api_DIR)/grammar.ml
	$(RM) $(Print_api_DIR)/grammar.mli
	$(RM) $(Print_api_DIR)/lexer.ml

=== src/dummy/hello_world/Makefile ===
--- 
+++ 
@@ -2,8 +2,8 @@
 #                                                                        #
 #  This file is part of Frama-C.                                         #
 #                                                                        #
-#  Copyright (C) 2007-2013                                               #
-#    CEA (Commissariat  l'nergie atomique et aux nergies              #
+#  Copyright (C) 2007-2014                                               #
+#    CEA (Commissariat à l'énergie atomique et aux énergies              #
 #         alternatives)                                                  #
 #                                                                        #
 #  you can redistribute it and/or modify it under the terms of the GNU   #

=== src/wp/qed/src/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #                                                                        #
 #  This file is part of WP plug-in of Frama-C.                           #
 #                                                                        #
-#  Copyright (C) 2007-2013                                               #
+#  Copyright (C) 2007-2014                                               #
 #    CEA (Commissariat a l'energie atomique et aux energies              #
 #         alternatives)                                                  #
 #                                                                        #
@@ -35,17 +35,18 @@
 LBO= $(addsuffix .cmo,$(LIB_ML))
 LBX= $(addsuffix .cmx,$(LIB_ML))
 CML= $(addsuffix .cmi,$(SRC_MLI))
-CMI= $(CML) $(addsuffix .cmi,$(SRC_ML))
 CMO= $(addsuffix .cmo,$(SRC_ML))
 CMX= $(addsuffix .cmx,$(SRC_ML))
+CMI= $(addsuffix .cmi,$(LIB_ML) $(SRC_MLI) $(SRC_ML))
 DOC= $(addsuffix .mli,$(LIB_ML) $(SRC_MLI) $(SRC_ML))
 
-.PHONY: all byte opt doc
+.PHONY: all byte opt doc dot
 
 all:  byte opt
 byte: ../bin/Qed.cmo Makefile Makefile.src
 opt:  ../bin/Qed.cmx Makefile Makefile.src
 doc:  ../html/index.html
+dot:  depend.pdf
 
 Qed.cmo: $(LBO) $(CMO) $(CML)
 	$(OCAMLC) -pack -o $@ $(LBO) $(CML) $(CMO)
@@ -58,7 +59,6 @@
 	$(OCAMLOPT) -pack -for-pack $(PACK) -o $@ $(LBX) $(CML) $(CMX)
 endif
 
-
 ../bin/Qed.cmo: Qed.cmo
 	@mkdir -p ../bin
 	cp Qed.cmo Qed.cmi ../bin/
@@ -67,34 +67,34 @@
 	@mkdir -p ../bin
 	cp Qed.cmx Qed.cmi Qed.o ../bin/
 
-../html/index.html: $(DOC) Makefile
+../html/index.html: $(DOC) Makefile feedback.ml
 	@rm -fr ../html
 	@mkdir -p ../html
-	$(OCAMLDOC) -html -d ../html -t "Qed Library" -stars $(DOC)
+	$(OCAMLDOC) -v -html -d ../html -t "Qed Library" -stars $(DOC) | ocaml unix.cma feedback.ml
 	@cp -f ocamldoc.css ../html/style.css
 
-depend: lexer.ml numbers.ml
+depend: numbers.ml
 
 depend.pdf: depend.dot
 	dot -T pdf -Grotate=180 -o $@ $<
 
-depend.dot: .depend
+depend.dot: .depend $(CMI)
 	$(OCAMLDOC) -dot-reduce -o $@ -dot $(addsuffix .mli,$(SRC_MLI)) $(addsuffix .ml,$(LIB_ML) $(SRC_ML))
 
 clean::
 	rm -fr ../html
-	rm -f lexer.ml depend.dot depend.pdf
+	rm -f depend.dot depend.pdf
 
 distclean::
 	rm -f ../bin/Qed.*
 
 INCLUDES=
 OPTCMI=
-OPTCMO= -w PSUZ -warn-error PSUZ
+OPTCMO= -annot -w PSUZ+7 -warn-error PSUZ+7
 ifeq ($(PACK),no)
-OPTCMX= -w PSUZ -warn-error PSUZ -for-pack Qed
+OPTCMX= -annot -w PSUZ+7 -warn-error PSUZ+7 -for-pack Qed
 else
-OPTCMX= -w PSUZ -warn-error PSUZ -for-pack $(PACK).Qed
+OPTCMX= -annot -w PSUZ+7 -warn-error PSUZ+7 -for-pack $(PACK).Qed
 endif
 
 include MakeOcaml

=== src/wp/share/coqwp/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of WP plug-in of Frama-C.                           #
#                                                                        #
#  Copyright (C) 2007-2014                                               #
#    CEA (Commissariat a l'energie atomique et aux energies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# --------------------------------------------------------------------------
# --- WP-Coq Libraries
# --------------------------------------------------------------------------

INCLUDES= -R . -as ""

include ../Makefile.resources
include ../Makefile.coq

compile: $(addsuffix o, $(COQ_LIBS_CEA) $(COQ_LIBS_INRIA))

# End of file

=== src/wp/share/why3/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of WP plug-in of Frama-C.                           #
#                                                                        #
#  Copyright (C) 2007-2014                                               #
#    CEA (Commissariat a l'energie atomique et aux energies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# --------------------------------------------------------------------------
# --- WP-Coq Libraries
# --------------------------------------------------------------------------

WHY3LIB=$(shell why3 --print-libdir)
INCLUDES= -R $(WHY3LIB)/coq -as Why3 -I .

include ../Makefile.resources
include ../Makefile.coq

compile: $(addsuffix o, $(COQ_LIBS_CEA))

# End of file

=== debian/changelog ===
frama-c (20140301+neon+dfsg-3) unstable; urgency=medium

  * Add a call to autoconf prior to configure.

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 29 Apr 2014 19:16:49 +0200

frama-c (20140301+neon+dfsg-2) unstable; urgency=medium

  * The new configure script tries to compile a test program linking
    against the OCamlgraph library. Unfortunately, upstream only tests
    the native case and fails for the bytecode case. Since, the OCamlgraph
    library is tested elsewhere, I'm adding a patch to disable that check.
    This resolves observed FTBFS on bytecode architectures (mips and mipsel).
    - Add 0005-Don-t-fail-during-the-configure-on-bytecode-architec.patch

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 28 Apr 2014 21:28:44 +0200

frama-c (20140301+neon+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patches
    - Remove 0005-Fix-compilation-with-OCaml-4.01.0.patch
    - Add 0004-Port-to-OCamlgraph-1.8.5.patch (Closes: #746091)
  * Bump build-dependency of Ocamlgraph to 1.8.5~.
  * Pass --enabe-zarith to configure script instead of patching it.
    - Remove 0004-Fix-auto-detection-of-ocaml-zarith.patch.

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 27 Apr 2014 21:41:47 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  graphviz,
  autoconf,
  libzarith-ocaml-dev,
- libocamlgraph-viewer-ocaml-dev (>> 1.8.3~),
+ libocamlgraph-viewer-ocaml-dev (>> 1.8.5~),
  liblablgtk2-gnome-ocaml-dev (>= 2.14.0+dfsg-2~),
  liblablgtksourceview2-ocaml-dev (>= 2.14.0+dfsg-2~)
 Standards-Version: 3.9.2

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,7 @@
 	mkdir -p lib/gui
 	touch .depend .make-clean .make-clean-stamp
 	[ ! -f src/kernel/config.ml ] || cp src/kernel/config.ml src/kernel/config.ml.debian
+	autoconf
 	./configure $(CROSS) --prefix=/usr       \
 		--mandir=\$${prefix}/share/man   \
 		--infodir=\$${prefix}/share/info \
@@ -19,6 +20,7 @@
 		--disable-impact		 \
 		--disable-security		 \
 		--enable-verbosemake             \
+		--enable-zarith="$(OCAML_STDLIB_DIR)/zarith" \
 		CFLAGS="$(CFLAGS)"               \
 		LDFLAGS="-Wl,-z,defs"
